package ru.rutoken.Pkcs11;

/* rtpkcs11t.h include file for PKCS #11. */

/*
 * @author Aktiv Co. <hotline@rutoken.ru>
 */

public interface RtPkcs11Constants {

    public static final int CKR_CORRUPTED_MAPFILE = (Pkcs11Constants.CKR_VENDOR_DEFINED+1);
    public static final int CKR_WRONG_VERSION_FIELD = (Pkcs11Constants.CKR_VENDOR_DEFINED+2);
    public static final int CKR_WRONG_PKCS1_ENCODING = (Pkcs11Constants.CKR_VENDOR_DEFINED+3);

    /* Неверный формат данных, переданных на подпись в PINPad,
     * или пользователь отказался от подписи данных */
    public static final int CKR_PINPAD_DATA_INCORRECT = (Pkcs11Constants.CKR_VENDOR_DEFINED+0x6FB1); // 0x80006FB1
    /* Размер данных, переданных на подпись в PINPad, больше допустимого */
    public static final int CKR_PINPAD_WRONG_DATALEN = (Pkcs11Constants.CKR_VENDOR_DEFINED+0x6FB6); // 0x80006FB6

    /* GOST KEY TYPES */
    public static final int CKK_GOSTR3410 = 0x00000030;
    public static final int CKK_GOSTR3411 = 0x00000031;
    public static final int CKK_GOST28147 = 0x00000032;

    /* GOST OBJECT ATTRIBUTES */
    public static final int CKA_GOSTR3410_PARAMS = 0x00000250;
    public static final int CKA_GOSTR3411_PARAMS = 0x00000251;
    public static final int CKA_GOST28147_PARAMS = 0x00000252;

    /* GOST MECHANISMS */
    public static final int CKM_GOSTR3410_KEY_PAIR_GEN = 0x00001200;
    public static final int CKM_GOSTR3410 = 0x00001201;
    public static final int CKM_GOSTR3410_WITH_GOSTR3411 = 0x00001202;
    public static final int CKM_GOSTR3410_KEY_WRAP = 0x00001203;
    public static final int CKM_GOSTR3410_DERIVE = 0x00001204;
    public static final int CKM_GOSTR3411 = 0x00001210;
    public static final int CKM_GOSTR3411_HMAC = 0x00001211;
    public static final int CKM_GOST28147_KEY_GEN = 0x00001220;
    public static final int CKM_GOST28147_ECB = 0x00001221;
    public static final int CKM_GOST28147 = 0x00001222;
    public static final int CKM_GOST28147_MAC = 0x00001223;
    public static final int CKM_GOST28147_KEY_WRAP = 0x00001224;

    public static final int CKD_CPDIVERSIFY_KDF = 0x00000009;
    public static final int CKP_PKCS5_PBKD2_HMAC_GOSTR3411 = 0x00000002;

    public static final int TOKEN_FLAGS_ADMIN_CHANGE_USER_PIN = 0x00000001;
    public static final int TOKEN_FLAGS_USER_CHANGE_USER_PIN  = 0x00000002;

    public static final int TOKEN_TYPE_UNKNOWN               = 0xFF;
    public static final int TOKEN_TYPE_RUTOKEN_ECP           = 0x01;
    public static final int TOKEN_TYPE_RUTOKEN_LITE          = 0x02;
    public static final int TOKEN_TYPE_RUTOKEN               = 0x03;
    public static final int TOKEN_TYPE_RUTOKEN_PINPAD_FAMILY = 0x04;
    public static final int TOKEN_TYPE_RUTOKEN_ECPDUAL_USB   = 0x09;
    public static final int TOKEN_TYPE_RUTOKEN_ECPDUAL_BT    = 0x69;
    public static final int TOKEN_TYPE_RUTOKEN_ECPDUAL_UART  = 0xA9;
    public static final int TOKEN_TYPE_RUTOKEN_WEB           = 0x23;
    public static final int TOKEN_TYPE_RUTOKEN_SC_JC         = 0x41;
    public static final int TOKEN_TYPE_RUTOKEN_LITE_SC_JC    = 0x42;
    public static final int TOKEN_TYPE_RUTOKEN_KAZTOKEN_SC_JC= 0x51;
    public static final int TOKEN_TYPE_RUTOKEN_ECP_SD        = 0x81;
    public static final int TOKEN_TYPE_RUTOKEN_LITE_SD       = 0x82;
    public static final int TOKEN_TYPE_RUTOKEN_KAZTOKEN_SD   = 0x91;

}
